%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Check_Nodes()

% DB_NODES (карточка GRID) | .ID | .Ref_Location(3,1) | .Location(3,1) | .Reference_CID | .Analysis_CID |

global ErrCode;
global AT_COORD;
global DB_NODES;

global BDF_Entity_Read_Settings;

fprintf (1, 'Проверка узлов...                       ');

% Установка настроек проверок
switch BDF_Entity_Read_Settings.Read_COORD
    case 'ON'
        Coord_Related_Checks = 1;
    case 'OFF'
        Coord_Related_Checks = 0;
    otherwise
        fprintf (1, '\nОшибка: непредвиденное значение параметра чтения BDF_Entity_Read_Settings.Read_COORD [%s] !\n', BDF_Entity_Read_Settings.Read_COORD);
        ErrCode = -1;
        return;
end

if (~isempty(AT_COORD))
    Max_Coord_Number = size(AT_COORD,1);
else
    Max_Coord_Number = 0;
end

for i=1:size(DB_NODES,1)
    
    % Проверка референсной системы координат
    if (Coord_Related_Checks == 1)
    
        if (DB_NODES{i}.Reference_CID ~= 0)

            if (DB_NODES{i}.Reference_CID > Max_Coord_Number)

                fprintf (1, 'Узел %i ссылается на несуществующую референсную систему координат %i !\n', DB_NODES{i}.ID, DB_NODES{i}.Reference_CID);
                ErrCode = -1;
                return;

            end

            if (AT_COORD(DB_NODES{i}.Reference_CID) == 0)

                fprintf (1, 'Узел %i ссылается на несуществующую референсную систему координат %i !\n', DB_NODES{i}.ID, DB_NODES{i}.Reference_CID);
                ErrCode = -1;
                return;

            end

        end
    
    end
    
    % Проверка системы координат анализа
    if (Coord_Related_Checks == 1)
        
        if (DB_NODES{i}.Analysis_CID ~= 0)

            if (DB_NODES{i}.Analysis_CID == -1)

                fprintf (1, 'Узел %i ссылается на систему координат анализа с номером -1 !\n', NODES(i,1));
                fprintf (1, 'Случай CD = -1 (fluid grid point in coupled fluid-structural analysis) не поддерживаются в текущей версии программы.\n');
                fprintf (1, 'Обратетись к разработчику для решения этого вопроса.\n');
                ErrCode = -1;
                return;

            end

            if (DB_NODES{i}.Analysis_CID > Max_Coord_Number)

                fprintf (1, 'Узел %i ссылается на несуществующую систему координат анализа %i !\n', DB_NODES{i}.ID, DB_NODES{i}.Analysis_CID);
                ErrCode = -1;
                return;

            end

            if (AT_COORD(DB_NODES{i}.Analysis_CID) == 0)

                fprintf (1, 'Узел %i ссылается на несуществующую систему координат анализа %i !\n', DB_NODES{i}.ID, DB_NODES{i}.Analysis_CID);
                ErrCode = -1;
                return;

            end

        end
    
    end
    
end

fprintf (1, 'OK!\n');
